//
// Created by webpigeon on 29/12/22.
//

#ifndef COMP290_WORKSHEETS_GRAPH_HPP
#define COMP290_WORKSHEETS_GRAPH_HPP

#include <vector>
#include <map>


struct Arc {
	char to;
	float weight;
};

constexpr float NOT_FOUND = 0.0F;

class Graph {
	public:
		void addArc(char from, char to, float weight = 1.0F);
		inline void addEdge(char from, char to, float weight = 1.0F) {
		    addArc(from, to, weight);
		    addArc(to, from, weight);
		}

		std::vector<char> getArcs(char from);

		float getWeight(char from, char to);

		inline bool hasVertex(char vertex) const {
			return m_list.find( vertex ) != m_list.end();
		}
	private:
		// there is a better structure we can use
		std::map<char, std::vector<Arc>> m_list;
};

#endif //COMP290_WORKSHEETS_GRAPH_HPP
