#ifndef LABS_TREES_TREES_HPP
#define LABS_TREES_TREES_HPP

#include <ostream>

struct Node {
	int value;
	Node* left = nullptr;
	Node* right = nullptr;

	inline bool isLeaf() const {
		return left == nullptr && right == nullptr;
	}
};


struct TrieNode {
    TrieNode* children[256] = {nullptr};
    bool valid;
    int value = 0;
};


void trie_insert(TrieNode* root, char* word, int value) {
    if ( root == nullptr ) {
        // I am sad :(
        return;
    }

    //TrieNode* currNode = root;
    char* nextChar = word;
    while (*nextChar != '\0') {
        if ( root->children[*nextChar] == nullptr) {
            root->children[*nextChar] = new TrieNode();
        }
        root = root->children[*nextChar];
        nextChar = nextChar + 1;
    }
    root->valid = true;
    root->value = value;
}

bool trie_find(TrieNode* curr, char* word) {
    if ( curr == nullptr ) {
        return false;
    }
    if ( word[0] == '\0') {
        return true;
    }
    return trie_find(curr->children[word[0]], &(word[1]));
}

char myword[] = {'h','e', 'l', 'l', 'o', '\0'};

// unbalanced
void add_node(Node* root, int newValue);
bool search(const Node* root, int searchValue);

// utility methods
void print_tree(std::ostream& out, Node* root, int depth=0);
void print_tree_dia(std::ostream& out, Node* root);

#endif // LABS_TREES_TREES_HPP