
#include "graph/graph.hpp"
#include <iostream>

void Graph::addArc(char from, char to, float weight = 1.0F)  {
  auto& links = m_list[from];
  links.push_back({ .to = to, .weight = weight });
}

		std::vector<char> Graph::getArcs(char from) {
			std::vector<char> arcs;
			for ( auto& arc : m_list.at(from) ) {
				arcs.push_back( arc.to );
			}
			return arcs;
		}

		float Graph::getWeight(char from, char to) {
			auto& links = m_list.at(from);
			for (auto& link : links) {
				if ( link.to == to ) {
					return link.weight;
				}
			}
			return NOT_FOUND;
		}

int main( int argc, char* argv[] ) {
	Graph graph;
	graph.addEdge('A', 'C', 2);
	graph.addEdge('A', 'B', 3);
	graph.addEdge('C', 'E', 6);
	graph.addEdge('C', 'D', 10);
	graph.addEdge('B', 'E', 2);
	graph.addEdge('E', 'D', 5);

	std::cout << graph.getWeight('a', 'b') << std::endl;
	std::cout << graph.hasVertex('d') << std::endl;
	return 0;
}
