#include "labs/trees/trees.hpp"

#include <iostream>

void add_node(Node* parent, int newValue) {
	if (parent->value > newValue) {
		if (parent->left == nullptr) {
			parent->left = new Node();
			parent->left->value = newValue;
		}
		else {
			add_node(parent->left, newValue);
		}
	}
	else {
		if (parent->right == nullptr) {
			parent->right = new Node();
			parent->right->value = newValue;
		}
		else {
			add_node(parent->right, newValue);
		}
	}
}

bool search(const Node* root, int value) {
	// TODO there is a bug in this code, what is it?
	// use the unit test results to help you find it
	// vcpkg instlal gtest:x64-windows
	if (root == nullptr) {
		return false;
	}

	if (root->value == value) {
		return true;
	}
	else if (root->value < value) {
		return search(root->left, value);
	}
	else {
		return search(root->right, value);
	}

}

void print_tree(std::ostream& out, Node* root, int depth) {
	for (int i = 0; i < depth; ++i) {
		out << '\t';
	}

	if (root == nullptr) {
		out << "null" << std::endl;
		return;
	}

	std::cout << root->value << std::endl;
	if (!root->isLeaf()) {
		print_tree(out, root->left, depth + 1);
		print_tree(out, root->right, depth + 1);
	}
}

static void print_tree_dia_node(std::ostream& out, Node* node) {
	if (node->isLeaf()) {
		return;
	}

	if (node->left != nullptr) {
		out << "\t" << node->value << " -> " << node->left->value << "[label=l];" << std::endl;
		print_tree_dia_node(out, node->left);
	} else {
		out << "\t" << node->value << " -> l" << node->value << "[label=l];" << std::endl;
		out << "\tl" << node->value << "[label=N];" << std::endl;
	}

	if (node->right != nullptr) {
		out << "\t" << node->value << " -> " << node->right->value << "[label=r];" << std::endl;
		print_tree_dia_node(out, node->right);
	} else {
		out << "\t" << node->value << " -> r" << node->value << "[label=r];" << std::endl;
		out << "\tr" << node->value << "[label=N];" << std::endl;
	}
}

void print_tree_dia(std::ostream& out, Node* root) {
	out << "digraph tree { " << std::endl;
	print_tree_dia_node(out, root);
	out << "}" << std::endl;
}